/// Status of a resource that is provided to the UI.
///
enum ResourceStatus {
  LOADING, //specifies the resource is loading
  TRANSIENT, //specifies the resource is in a undefined transitory state
  SUCCESS, //specifies the resource is successfully loaded
  ERROR, //specifies there was an error loading the resource
}

extension ResourceUtils on ResourceStatus {
  bool get isLoading => this == ResourceStatus.LOADING;
  bool get isTransient => this == ResourceStatus.TRANSIENT;
  bool get isSuccess => this == ResourceStatus.SUCCESS;
  bool get isError => this == ResourceStatus.ERROR;
}
